<template>
  <div>
    <q-btn  style="margin-top:30px; margin-left: 30px" color="orange" icon="arrow_back" label="Kembali"
            to="/jenis-produk" />

    <q-form
      @submit="onSubmit"
      @reset="onReset"
      class="q-gutter-md"
    >
      <div class="q-pa-md" style="width: 80%; background: #4caf50; color: white; margin-top: 50px; margin-left: auto; margin-right: auto; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
        <h6 style="margin: 0px">Tambah Jenis Produk</h6>
      </div>
      <div class="q-pa-md" style="width: 80%; padding: 0; margin: auto; margin-top: 0px; padding-bottom: 20px; box-shadow: 0 0px 8px 0 rgba(0,0,0,0.2), -7px 0 5px -3px #4caf50">
        <div>
          <p>&nbsp;</p>
          <h6 style="margin-left: 70px; margin-top: 0px; margin-bottom: 10px">Data Jenis Produk</h6>
          <div class="q-gutter-y-md" style="width: 85%; margin: auto; margin-bottom: 10px;" >
            <q-input
              standout="bg-green text-white"
              v-model="form.product_type"
              label="Jenis Produk"
              :rules="[ val => val && val.length > 0 || 'Isi Jenis Produk']"
            />
            <q-select
              standout="bg-green text-white" v-model="form.level_req" :options="optionBadanUsaha" label="Kebutuhan Level" />
            <!--            <q-btn-toggle-->
            <!--              v-model="form.is_jasa"-->
            <!--              push-->
            <!--              glossy-->
            <!--              toggle-color="primary"-->
            <!--              :options="[-->
            <!--                {label: 'Jasa', value: 1},-->
            <!--                {label: 'Lowongan Kerja', value: 0},-->
            <!--                {label: 'Proyek', value: 2},-->
            <!--                {label: 'Produk', value: 3}-->
            <!--              ]"-->
            <!--            />-->
          </div>
        </div>
      </div>
    </q-form>

    <q-card style="margin-top: 20px; margin-left: auto; margin-right:auto; margin-bottom: 50px; width: 80%">
      <q-card-actions>
        <q-btn color="green" icon="add" label="Tambah Form" @click="tambahForm" />
      </q-card-actions>
    </q-card>
    <div style="margin-top: 20px; margin-left: auto; margin-right:auto; margin-bottom: 50px; width: 80%">
      <q-card v-for="form in formTambahan" style="margin-top: 20px">
        <q-card-actions>
          <q-btn-dropdown color="primary" label="Tambah Komponen Form" size="sm">
            <q-list>
              <div v-for="option in optionKomponen">
                <q-item clickable v-close-popup @click="tambahKomponenForm(form, option)">
                  <q-item-section>
                    <q-item-label>{{ option.label }}</q-item-label>
                  </q-item-section>
                </q-item>
              </div>
            </q-list>
          </q-btn-dropdown>
          <q-btn icon="delete" color="red" @click="removeForm(form)" size="sm" />
          <q-checkbox v-model="form.multiple" label="multiple" />

        </q-card-actions>

        <q-card-section>
          <q-input v-model="form.judul" label="Nama Form" />
        </q-card-section>

        <div class="q-pa-md" v-for="komponens in form.komponen">
          <q-card style="margin-top: 10px">
            <q-card-actions>
              <q-btn icon="delete" color="red" @click="removeKomponen(komponens, form)" size="xs" />
              <q-checkbox v-model="komponens.required" label="required" />
            </q-card-actions>
            <q-card-section>
              Tipe : {{ komponens.type }}
            </q-card-section>
            <q-card-section>
              <div class="row q-gutter-lg">
                <div class="col-md-4">
                  <q-input v-model="komponens.label" label="Label Form" />
                </div>
                <div class="col-md-4">
                  <q-input v-model="komponens.hint" label="Hint" />
                </div>
                <div class="col-md-4">
                  <q-card>
                    <q-card-section v-if="komponens.pilihan">
                      <q-btn color="green" icon="add" @click="tambahOpsi(komponens)" size="sm" /> Options
                    </q-card-section>
                    <div v-for="opsi in komponens.option">
                      <q-card-section>
                        <div class="row">
                          <div class="col-4">
                            <q-input v-model="opsi.label" label="Label" />
                          </div>
                          <div class="col-4">
                            <q-input v-model="opsi.value" label="Value" />
                          </div>
                          <div class="col-4">
                            <q-btn icon="delete" color="red" @click="removeOption(komponens, form, opsi)" size="sm" />
                          </div>
                        </div>
                      </q-card-section>
                    </div>
                  </q-card>
                </div>
              </div>
            </q-card-section>

          </q-card>
        </div>
      </q-card>
    </div>

    <div style="margin-top: 20px; margin-left: auto; margin-right:auto; margin-bottom: 50px; width: 80%">
      <q-btn  label="Simpan Jenis Produk" @click="onSubmit" color="green"/>
    </div>
  </div>
</template>

<script>
export default {
  data () {
    return {
      token : `Bearer ${localStorage.getItem("token")}`,
      optionBadanUsaha: [],
      optionKomponen: [
        {
          label: "Text",
          value: "text",
          pilihan: false
        },
        {
          label: "TextArea",
          value: "textarea",
          pilihan: false
        },
        {
          label: "Select Option",
          value: "select",
          pilihan: true
        },
        {
          label: "Checkbox",
          value: "checkbox",
          pilihan: true
        },
        {
          label: "Radio Button",
          value: "radio",
          pilihan: true
        },
        {
          label: "Email",
          value: "email",
          pilihan: false
        },
        {
          label: "Date and Time",
          value: "datetime",
          pilihan: false
        },

        {
          label: "Date",
          value: "date",
          pilihan: false
        },
        {
          label: "Time",
          value: "time",
          pilihan: false
        },
        {
          label: "Password",
          value: "password",
          pilihan: false
        },
        {
          label: "File",
          value: "file",
          pilihan: false
        },
      ],
      form: {
        product_type: null,
        level_req: null,
        is_jasa: 1,
      },
      formTambahan: []
    }
  },

  beforeMount() {
    this.getSelectBadanUsaha()
  },

  methods: {
    tambahOpsi: function (komponen) {
      let data = {
        label: "Label",
        value: "value"
      }
      komponen.option.push(data);
    },
    removeOption: function (komponen, form, opsi) {
      komponen.option.splice(komponen.option.indexOf(opsi), 1);
    },

    removeKomponen: function (komponen, form) {
      this.formTambahan[this.formTambahan.indexOf(form)].komponen.splice(this.formTambahan[this.formTambahan.indexOf(form)].komponen.indexOf(komponen), 1);
    },


    tambahKomponenForm: function (form, option) {

      let data = {
        'type' : option.value,
        'label': 'Label',
        'required': true,
        'hint': "",
        'pilihan': option.pilihan,
        'option': []
      }

      form.komponen.push(data)
    },
    removeForm: function (val) {
      console.log("Form Tambahan", val);
      this.formTambahan.splice(this.formTambahan.indexOf(val), 1);
    },
    tambahForm: function () {
      let dataForm = {
        judul: "Form Tambahan " + (parseInt(this.formTambahan.length) + 1),
        multiple: true,
        komponen: []
      };
      this.formTambahan.push(dataForm)
    },

    getSelectBadanUsaha: function () {
      this.$q.loading.show()

      let dataSelectBadanUsaha  = {
        method: "GET",
        url: "api/business/select",
        headers: {
          Authorization: this.token
        }
      }

      this.$axios(dataSelectBadanUsaha)

        .then(sukses => {
          this.$q.loading.hide()
          this.optionBadanUsaha = sukses.data
        })

        .catch(error => {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: `ERROR ! ${error.response.data.message}`
          })
        })
    },

    onSubmit () {
      let formData = new FormData();

      formData.append("product_type", this.form.product_type)
      formData.append("level_req", this.form.level_req.value)
      formData.append("is_jasa", this.form.is_jasa)
      formData.append("form_tambahan", JSON.stringify(this.formTambahan))

      let dataApi = {
        method: "POST",
        url: "api/product-type/create",
        headers: {
          Authorization: this.token
        },
        data: formData
      }

      this.$q.loading.show()
      this.$axios(dataApi)

        .then(sukses => {
          this.$q.notify({
            color: 'green-4',
            textColor: 'white',
            icon: 'cloud_done',
            message: 'Berhasil Simpan Jenis Produk'
          })
          this.$q.loading.hide()
          this.$router.push("/jenis-produk")
        })

        .catch(error => {
          this.$q.notify({
            color: 'red-5',
            textColor: 'white',
            icon: 'warning',
            message: `ERROR ! ${error.response.data.message || error.response.data.error}`
          })
          this.$q.loading.hide()
          console.log("Error Koneksi : ", error.response)
        })

    },

    onReset () {
      this.name = null
      this.age = null
      this.accept = false
    }
  }
}

</script>

<style scoped>

</style>
